#include <sys/ptrace.h>
#include <sys/types.h>
#include <sys/user.h>
#include <sys/wait.h>

#include <unistd.h>
#include <stdio.h>

int
main (int argc, char ** argv)
{
  long addr;
  int status = 0;
  struct user_regs_struct regs;

  if (argc != 2) {
    fprintf (stderr, "usage: %s target\n", argv[0]);
    return 1;
  }

  int pid = fork ();

  if (!pid)
    {  
      ptrace (PTRACE_TRACEME, 0, 0, 0);
      execlp (argv[1], "");
    }
  else
    {  
      wait (&status);
      while (1)
        {
          addr = ptrace (PTRACE_SINGLESTEP, pid, 0, 0);
          wait (&status);
          if (WIFEXITED (status)) {
            break;
          }
          ptrace (PTRACE_GETREGS, pid, 0, &regs);
#ifdef _x86_32
          if (regs.eax == 0xDEADBEAF) {
#else          
          if (regs.rax == 0xDEADBEAF) {
#endif

#ifdef FIRSTT            
#ifdef _x86_32            
            fprintf (stdout, "val: %X\n", regs.eax);
#else
            fprintf (stdout, "val: %X\n", regs.rax);
#endif
            ptrace (PTRACE_KILL, pid, 0, 0);
            break;
#else 
#ifdef _x86_32        
            regs.eax = 1;
#else            
            regs.rax = 1;
#endif
            ptrace (PTRACE_SETREGS, pid, 0, &regs);
#endif
          }
        }
    }

  return 0;
}
