#include <stdio.h>
#include <dlfcn.h>

#include <test.h>

int main ()
{
  void *handle;
  char *error;
  
  void (*init_sym)();
  void (*add_sym)();
  void (*print_result_sym)();

  if ((handle = dlopen ("libtest.so", RTLD_LAZY)) == NULL) 
  {
    fprintf (stderr, "%s\n", dlerror());
    return 1;
  }

  init_sym = dlsym(handle, "init");
  if ((error = dlerror()) != NULL)  {
    fprintf (stderr, "%s\n", error);
    return 1;
  }

  add_sym = dlsym(handle, "add");
  if ((error = dlerror()) != NULL)  {
    fprintf (stderr, "%s\n", error);
    return 1;
  }

  print_result_sym = dlsym(handle, "print_result");
  if ((error = dlerror()) != NULL)  {
    fprintf (stderr, "%s\n", error);
    return 1;
  }
  
  (*init_sym) ();
  (*add_sym) ();
  (*print_result_sym) ();

  dlclose (handle);

  return 0;
}
