#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include <string.h>

#define DBGI(a) printf(#a " ==> %d\n", a)
#define DBGF(a) printf(#a " ==> %f\n", a)
#define DBGC(a) printf(#a " ==> %c\n", a)
#define DBGS(a) printf(#a " ==> %s\n", a)
#define DBGA(a) printf(#a " ==> %x\n", a)
#define HIM printf ("Here I am\n")

void usage (char * name) {

  fprintf (stderr, "usage: %s [options] filename\n\n", name);
  fprintf (stderr, " -v, --val[=val]        : float \n");
  fprintf (stderr, " -o, --other-val[=val]  : float \n");
  fprintf (stderr, " -h, --help             : display this help and exit\n");

  exit (1);
}

int main (int argc, char ** argv) {

  float val, othrval;
  char * name;

  val = 0.0;
  othrval = 0.0;

  while (1) {
    int c;
    static struct option long_options[] = {
      {"help", no_argument, NULL, 'h'},
      {"val", required_argument, NULL, 'v'},
      {"other-val", required_argument, NULL, 'o'},
      {0,0,0,0}
    };

    c = getopt_long (argc, argv, "", long_options, NULL);
    
    if (c == -1)
      break;

    switch (c) {
      case 'v':
        val = atof (optarg);
        break;
      case 'o':
        othrval = atof (optarg);
        break;
      case 'h':
        usage (argv[0]);
      default:
        usage (argv[0]);
    }
  }
  
  // optind variabile globale indice di posizione
  if (optind >= argc) 
    usage (argv[0]);

  name = alloca (strlen(argv[optind]) + 1);
  strcpy (name, argv[optind]);

  fprintf (stdout, "%s == %f, %f\n", name, val, othrval);
  
  return 0;
}
