#include <linux/init.h>
#include <linux/module.h>
MODULE_LICENSE("Dual BSD/GPL");

static int __init hello_init(void) {
  printk(KERN_ALERT "Hello, world\n");
  return 0;
}

static void __exit hello_exit(void) {
  printk(KERN_ALERT "Goodbye, cruel world\n");
  return;
}

/*
Le 8 priorità dei messaggi del kernel:

     #define KERN_EMERG   "<0>"  system is unusable                  
     #define KERN_ALERT   "<1>"  action must be taken immediately 
     #define KERN_CRIT    "<2>"  critical conditions              
     #define KERN_ERR     "<3>"  error conditions                 
     #define KERN_WARNING "<4>"  warning conditions               
     #define KERN_NOTICE  "<5>"  normal but significant condition 
     #define KERN_INFO    "<6>"  informational                    
     #define KERN_DEBUG   "<7>"  debug-level messages             
*/

module_init(hello_init);
module_exit(hello_exit);
