#include <stdio.h>
#include <stdlib.h>

#include "utilmtx.h"

double ** alloca_mtx (int n) {
  double ** a, * temp;
  int i;

  if ( (a = (double **) malloc (sizeof (double *) * n)) == NULL) {
    return NULL;
  }
  else {
    if ( (temp = (double *) malloc (sizeof (double) * n * n)) == NULL) {
      return NULL;
    }
    else {
      for (i=0; i<n; i++) 
        a[i] = &temp[i*n]; 
    }
  }

  return a;
} 

void free_mtx (double ** a) {

  free (a[0]);
  free (a);

  return;
}

void fill_mtx (double ** a, int n) {
  int i, j;

  for (i=0; i<n; i++) 
    for (j=0; j<n; j++)
      a[i][j] = 1.0e0 + (double) (1.0e0 * n * (rand() / (RAND_MAX + 1.0e0))); 
}

void print_mtx (double ** a, int n) {
  int i, j;

  fprintf (stdout, "\n");
  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      fprintf (stdout, "%10.5f ", a[i][j]);
    }
    fprintf (stdout, "\n");
  }

  return;
}
