#include <stdio.h>
#include <stdlib.h>

#include <utilmtx.h>

int main (int argc, char ** argv) {

  int n;
  double ** a;

  if (argc != 2) {
    fprintf (stderr, "usage: %s N\n", argv[0]);
    return EXIT_FAILURE;
  } 

  if ( (n = atoi (argv[1])) < 0) {
    fprintf (stderr, "N must be gt 0\n");
    return EXIT_FAILURE;
  }

  if ((a = alloca_mtx (n)) == NULL) {
    fprintf (stderr, "Memory allocation error\n");
    return EXIT_FAILURE;
  }

  fill_mtx (a, n);
  
  print_mtx (a, n);
  
  free_mtx (a);

  return EXIT_SUCCESS;
}
