#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>

static double a, b;

void somma (int unu) {

  fprintf (stdout, "\n %10.5f + %10.5f = %10.5f \n", a, b, a+b);
  fflush (stdout);

  return;
} 

void diff (int unu) {

  fprintf (stdout, "\n %10.5f - %10.5f = %10.5f \n", a, b, a-b);
  fflush (stdout);

  return;
} 

int main(int argc, char** argv, char** env)
{

  pid_t pid;

  if (argc != 3) {
    fprintf (stderr, "usage: %s num1 num2\n", argv[0]);
    return EXIT_FAILURE;
  }

  a = atof (argv[1]);
  b = atof (argv[2]);
  
  pid = fork ();

  if (pid == -1) {
    fprintf (stdout, "fork failed\n");
    return EXIT_FAILURE;
  }
  else if (pid == 0) {
    if (signal (SIGPWR, somma) == SIG_ERR) { 
      fprintf (stderr, "error\n");
      return EXIT_FAILURE;
    }
  
    if (signal (SIGSYS, diff) == SIG_ERR) { 
      fprintf (stderr, "error\n");
      return EXIT_FAILURE;
    }
  
    while (1) {
      sleep (1000);
      //fprintf (stderr, "wakeup");
    };

    return EXIT_SUCCESS;
  }
  else {
    fprintf (stdout, "I am the parent\n");

    return EXIT_SUCCESS;
  }

  return EXIT_SUCCESS;
}
